cda.header.serviceevent = {}

cda.header.serviceevent.performer = {}

-------------------------------------------------------------------------------
-- All functions in cda.header.serviceevent accept a <serviceEvent> element. --
-------------------------------------------------------------------------------

-- Default precision is 3 (YYYYMMDD)
function cda.header.serviceevent.addEffectiveTime(SE)
   return imp.getOrCreateElement(SE, 'effectiveTime')
end

local PERFORMER_TEMPLATE = [[
<templateId root="2.16.840.1.113883.3.88.11.83.4" assigningAuthorityName="HITSP C83"/>
<templateId root="1.3.6.1.4.1.19376.1.5.3.1.2.3" assigningAuthorityName="IHE PCC"/>
<functionCode code="#" displayName="#">
   <originalText>#</originalText>
</functionCode>
]]

-- Use cda.header.serviceevent.performer functions with the return value
function cda.header.serviceevent.addPerformer(SE, TypeCode, Code, DisplayName)
   local P = SE:append(xml.ELEMENT, 'performer')
   P:setAttr('typeCode', TypeCode)
   P:setInner(PERFORMER_TEMPLATE)
   P.functionCode.code = Code
   P.functionCode.displayName = DisplayName
   cda.codesystem.set(P.functionCode, cda.cs.ProviderRole)
   P.functionCode.originalText[1] = DisplayName
   return P
end


--------------------------------------------------------------------------------------
-- All functions in cda.header.serviceevent.performer accept a <performer> element. --
--------------------------------------------------------------------------------------

function cda.header.serviceevent.performer.addTime(P)
   return imp.getOrCreateElement(P, 'time')
end

function cda.header.serviceevent.performer.addAssignedEntity(P, Root, Extension, AssigningAuthorityName)
   return imp.createChildWithId(P, 'assignedEntity', Root, Extension, AssigningAuthorityName)
end
